exports.readFile = function(filePath, processor, callback, progress, splitChar, bufferSize) {
	splitChar = splitChar === undefined ? "\n" : splitChar;
	bufferSize = bufferSize === undefined ? 2 : bufferSize;
	progress = typeof progress === 'function' ? progress : function() {};
	let file = Ti.Filesystem.getFile(filePath);
	if (file.exists()) {
		let fileSize = file.size;
		let totalProcessed = 0;
		let f = Ti.Filesystem.openStream(Ti.Filesystem.MODE_READ, filePath);
		let leftover = "";
		let contentBuffer = Ti.createBuffer({
			length: bufferSize
		});
		var readerCallback = function(bytesRead) {
			console.warn('---- 2. Reader Callback');
			if (bytesRead.bytesProcessed != contentBuffer.length) contentBuffer.length = bytesRead.bytesProcessed;
			totalProcessed += Number(bytesRead.bytesProcessed);
			progress(Math.round((totalProcessed / fileSize) * 100));
			let lines = String(contentBuffer).split(splitChar);
			lines[0] = leftover + lines[0];
			leftover = lines.pop();
			if (lines.length) lines.map((line) => ((line.length) ? processor(line) : null));
			contentBuffer.clear();
			if (bytesRead.bytesProcessed >= bufferSize) { // if cont then there is more to read
				f.read(contentBuffer, 0, bufferSize, readerCallback);
				console.warn('++++ 1. After Read');
			} else { // else run the processor on leftover then callback
				if (leftover.length) processor(leftover);
				f.close();
				if (typeof callback == 'function') callback();
			}
		};
		f.read(contentBuffer, 0, bufferSize, readerCallback);
		console.warn('++++ 1. After Read');
	}
};
